<?php
	 /* 
	 Plugin Name: CPT para Cursos Online
	 Plugin URI: https://avalos.sv 
	 Description: CPT Cursos Online para la web AVALOS.SV 
	 Version: 1.0.6
	 Author: Alex Avalos
	 Author URI: https://avalos.sv
	 License: GPL 2+ 
	 License URI: https://avalos.sv 
	 */ 
	// Registrar el CPT
	function cg_cpt_cursos() {

		$labels = array(
			'name'                  => _x( 'Cursos', 'cg-cpt-cursos' ),
			'singular_name'         => _x( 'Curso', 'cg-cpt-cursos' ),
			'menu_name'             => __( 'Cursos', 'cg-cpt-cursos' ),
			'archives'              => __( 'Todos los cursos', 'cg-cpt-cursos' ),
			'all_items'             => __( 'Todos los cursos', 'cg-cpt-cursos' ),
			'add_new_item'          => __( 'Añadir nuevo curso', 'cg-cpt-cursos' ),
			'add_new'               => __( 'Añadir curso', 'cg-cpt-cursos' ),
			'new_item'              => __( 'Nuevo curso', 'cg-cpt-cursos' ),
			'edit_item'             => __( 'Editar curso', 'cg-cpt-cursos' ),
			'update_item'           => __( 'Actualizar curso', 'cg-cpt-cursos' ),
			'view_item'             => __( 'Ver curso', 'cg-cpt-cursos' ),
			'search_items'          => __( 'Buscar curso', 'cg-cpt-cursos' ),
			'not_found'             => __( 'No encontrado', 'cg-cpt-cursos' ),
			'not_found_in_trash'    => __( 'No se encuentra en la papelera', 'cg-cpt-cursos' ),
			'insert_into_item'      => __( 'Insertar', 'cg-cpt-cursos' ),
			'uploaded_to_this_item' => __( 'Añadido a este curso', 'cg-cpt-cursos' ),
			'items_list'            => __( 'Listado de curso', 'cg-cpt-cursos' ),
			'items_list_navigation' => __( 'Navegación por los cursos', 'cg-cpt-cursos' ),
			'filter_items_list'     => __( 'Lista de cursos filtrados', 'cg-cpt-cursos' ),
		);

		$args = array(
			'label'                 => __( 'cursos', 'cg-cpt-cursos' ),
			'description'           => __( 'Los cursos disponibles', 'cg-cpt-cursos' ),
			'labels'                => $labels,
			'supports'              => array( 'page-attributes', 'title', 'editor', 'excerpt', 'thumbnail', 'custom-fields', 'genesis-cpt-archives-settings', 'genesis-seo', 'genesis-scripts', 'genesis-layouts', 'genesis-rel-author', ),
			'taxonomies'            => array( 'cursos_category' ),
			'hierarchical'          => true,
			'public'                => true,
			'show_ui'               => true,
			'show_in_menu'          => true,
			'menu_position'         => 10,
			'menu_icon'             => 'dashicons-welcome-learn-more',
			'show_in_admin_bar'     => true,
			'show_in_nav_menus'     => true,
	        'show_in_rest'          => true,
			'can_export'            => true,
			'has_archive'           => true,
			'exclude_from_search'   => false,
			'publicly_queryable'    => true,
			'query_var'             => 'cg-cpt-cursos',
			'rewrite' => array(
				'slug' => __( 'cursos', 'cg-cpt-cursos' ),
			),
			'capability_type'       => 'page',
		);
		register_post_type( 'cursos', $args );

	}
	add_action( 'init', 'cg_cpt_cursos', 0 );


	// Registrar una categoría
	function cg_cursos_category() {

		$labelsCategory = array(
			'name'                       => __( 'Categorías cursos', 'cg-cpt-cursos' ),
			'singular_name'              => __( 'Categoría cursos', 'Taxonomy Singular Name', 'cg-cpt-cursos' ),
			'all_items'                  => __( 'Todas las categorías', 'cg-cpt-cursos' ),
			'new_item_name'              => __( 'Nombre de la nueva categoría', 'cg-cpt-cursos' ),
			'add_new_item'               => __( 'Añadir categoría', 'cg-cpt-cursos' ),
			'edit_item'                  => __( 'Editar categoría', 'cg-cpt-cursos' ),
			'update_item'                => __( 'Actualizar categoría', 'cg-cpt-cursos' ),
			'view_item'                  => __( 'Ver categoría', 'cg-cpt-cursos' ),
			'separate_items_with_commas' => __( 'Separar categorías con comas', 'cg-cpt-cursos' ),
			'add_or_remove_items'        => __( 'Añadir o quitar categorías', 'cg-cpt-cursos' ),
			'choose_from_most_used'      => __( 'Elige entre las más usadas', 'cg-cpt-cursos' ),
			'popular_items'              => __( 'Categorías populares', 'cg-cpt-cursos' ),
			'search_items'               => __( 'Buscar categorías', 'cg-cpt-cursos' ),
			'not_found'                  => __( 'No encontrada', 'cg-cpt-cursos' ),
			'no_terms'                   => __( 'No hay categorías', 'cg-cpt-cursos' ),
			'items_list'                 => __( 'Lista de categorías', 'cg-cpt-cursos' ),
			'items_list_navigation'      => __( 'Navegación por la lista de categorías', 'cg-cpt-cursos' ),
		);

		$argsCategory = array(
			'labels'                     => $labelsCategory,
			'hierarchical'               => true,
			'public'                     => true,
			'show_admin_column'          => true,
			'show_in_rest'         		 => true,
			'rewrite'  => array(
				'slug' => __( 'categoria-cursos', 'cg-cpt-cursos' ),
			),

		);
		register_taxonomy( 'cursos_category', array( 'cursos' ), $argsCategory );
		
	}
	add_action( 'init', 'cg_cursos_category', 0 );

	// Resetear los enlaces permanetes tras la activación/desactivación del plugin
	register_deactivation_hook( __FILE__, 'flush_rewrite_rules' );
	register_activation_hook( __FILE__, 'cg_cpt_cursos_rewrite_flush' );

	function cg_cpt_cursos_rewrite_flush(){
	  cg_cpt_cursos();
	  flush_rewrite_rules();
	}
	
	//Listado clases 
	function mk_list_child_pages() { 
		global $post; 
			if ( $post->post_parent )
				$childpages = wp_list_pages( 'post_type=cursos&sort_column=menu_order&title_li=&child_of=' . $post->post_parent . '&echo=0' );
			else
				$childpages = wp_list_pages( 'post_type=cursos&sort_column=menu_order&title_li=&child_of=' . $post->ID . '&echo=0' );
			if ( $childpages ) { 
			$string = '<ul class="listado-clases">' . $childpages . '</ul>';
		}
	return $string; 
		}
	add_shortcode('listado-clases', 'mk_list_child_pages');
	
	// Eliminar la metainformación de la cabecera de todos los CPT
	add_action ( 'genesis_before_loop', 'cg_remove_cpt_info' );
	function cg_remove_cpt_info() {
		if ( 'post' !== get_post_type() ) {
			remove_action( 'genesis_entry_header', 'genesis_post_info', 12 );
			remove_action( 'genesis_entry_footer', 'genesis_post_meta' );
		}
	}
?>